﻿Imports System.IO
Imports System.Text

Module Module1

    Sub Main(args As String())
        Dim lists = New SortedArrayList(Of String)() {
                        New SortedArrayList(Of String)(),
                        New SortedArrayList(Of String)(),
                        New SortedArrayList(Of String)(),
                        New SortedArrayList(Of String)()}

        Using stream = New StreamReader(args(0), Encoding.Default)
            Dim line As String = stream.ReadLine()
            While line IsNot Nothing
                lists(0).Add(line)
                lists(1).Add(line)
                line = stream.ReadLine()
            End While
        End Using

        ' jeweils Hälfte der Liste in 2 und 3 kopieren
        For i As Integer = 0 To lists(0).Count - 1
            lists(2 + (i Mod 2)).Add(lists(0)(i))
        Next

        Dim w = New Stopwatch()

        w.Start()
        lists(0).MergeSort()
        w.Stop()
        Console.WriteLine(w.Elapsed)

        w.Restart()
        lists(1).MergeSortParallel()
        w.Stop()
        Console.WriteLine(w.Elapsed)

        w.Restart()
        Task.WaitAll(New Task() {
                Task.Run(Sub() lists(2).MergeSort()),
                Task.Run(Sub() lists(3).MergeSort())
                })

        lists(3) = SortedArrayList(Of String).Merge(New SortedArrayList(Of String)() {lists(2), lists(3)})

        w.Stop()
        Console.WriteLine(w.Elapsed)

        Console.ReadLine()

    End Sub

End Module
